package com.candidjava.hibernate;

import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;
import org.hibernate.criterion.Restrictions;

public class EmployeeDao {
	private static SessionFactory sessionFactory;

	private Session getSession() {
		Session s = null;
		try {
			sessionFactory = new Configuration().configure()
					.buildSessionFactory();
			s = sessionFactory.openSession();
		} catch (HibernateException e) {
			System.out.println(e.getMessage());
		}
		return s;
	}

	public void insertEmployee(Employee emp) {
		try {
			Session s = getSession();
			Transaction tx = s.beginTransaction();
			
			s.save(emp);
			tx.commit();
			
		} catch (HibernateException e) {
			System.out.println(e.getMessage());
		}
	}

	public List<Employee> search(){
		List<Employee> li = null;
		try {
			Session s = getSession();

			Criteria c = s.createCriteria(Employee.class);

			c.add(Restrictions.between("age", 20, 50));
	
			c.add(Restrictions.ge("salary", new Integer(30000)));
			
			c.add(Restrictions.le("salary", new Integer(50000)));
			
			c.add(Restrictions.in("city", new String[] { "Chennai", "Erode" }));
			
			c.add(Restrictions.eq("gender", "MALE"));

			li = c.list();
		} catch (HibernateException e) {
			System.out.println(e.getMessage());
		}
		return li;
	}

}
